Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## rice.pastry.routing
Class RoutingTable

    java.lang.Object
      java.util.Observable
          rice.pastry.routing.RoutingTable

All Implemented Interfaces:
  java.util.Observer

public class RoutingTable
extends java.util.Observable
implements java.util.Observer

The Pastry routing table.

The size of this table is determined by two constants:

- `nodeIdBitLength`which determines the number of bits in a node id (which we call n ).
- `idBaseBitLength`which is the base that table is stored in (which we call b ).

We write out node ids as numbers in base 2 b . They will have length D = ceiling(log 2 b 2 n ) . The table is stored from 0...(D-1) by 0...(2 b - 1) . The table stores a set of node handles at each entry. At address [index][digit] , we store the set of handles were the most significant (numerically) difference from the node id that the table routes for at the index th digit and the differing digit is digit . An index of 0 is the least significant digit.

Version:
  $Id: RoutingTable.java 2833 2005-12-13 14:14:16Z jeffh $
Author:
  Andrew Ladd, Peter Druschel

Field Summary
`int` | `idBaseBitLength` The routing calculations will occur in base 2 idBaseBitLength
`NodeHandle` | `myNodeHandle` DESCRIBE THE FIELD

Constructor Summary
`RoutingTable(NodeHandle me, int max, int base, Environment env)` Constructor.

Method Summary
`NodeSet` | `alternateRoutes(Id key, int max)` Determines a set of alternate hops towards a given key.
`int` | `baseBitLength()` return the bit length of the base
`NodeHandle` | `bestAlternateRoute(Id key)` Determines an alternate hop numerically closer to the key than the one we are at.
`NodeHandle` | `bestAlternateRoute(int minLiveness, Id key)` Determines an alternate hop numerically closer to the key than the one we are at.
`NodeHandle` | `get(NodeId nid)` Gets the node handle associated with a given id.
`RouteSet` | `getBestEntry(Id key)` Gets the set of handles that match at least one more digit of the key than the local nodeId.
`RouteSet` | `getRouteSet(int index, int digit)` Gets the set of handles at a particular entry in the table.
`RouteSet[]` | `getRow(int i)` Get a row from the routing table.
`int` | `numColumns()` return ths number of columns in the routing table
`int` | `numEntries()` DESCRIBE THE METHOD
`int` | `numRows()` return the number of rows in the routing table
`int` | `numUniqueEntries()` DESCRIBE THE METHOD
`void` | `put(NodeHandle handle)` Puts a handle into the routing table.
`NodeHandle` | `remove(NodeHandle nh)` Removes a node id from the table.
`java.lang.String` | `toString()` produces a String representation of the routing table, showing the number of node handles in each entry
`void` | `update(java.util.Observable o, java.lang.Object arg)` Is called by the Observer pattern whenever a RouteSet in this table has changed.

Methods inherited from class java.util.Observable
`addObserver, clearChanged, countObservers, deleteObserver, deleteObservers, hasChanged, notifyObservers, notifyObservers, setChanged`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### idBaseBitLength

    public int idBaseBitLength

  The routing calculations will occur in base 2 idBaseBitLength

### myNodeHandle

    public NodeHandle myNodeHandle

  DESCRIBE THE FIELD

Constructor Detail

### RoutingTable

    public RoutingTable(NodeHandle me,
                        int max,
                        int base,
                        Environment env)

  Constructor.

Parameters:
  `me` - the node id for this routing table.
  `max` - the maximum number of entries at each table slot.
  `base` - DESCRIBE THE PARAMETER
  `env` - DESCRIBE THE PARAMETER

Method Detail

### getRouteSet

    public RouteSet getRouteSet(int index,
                                int digit)

  Gets the set of handles at a particular entry in the table.

  Parameters:
    `index` - the index of the digit in base 2 idBaseBitLength .0 is the least significant.
    `digit` - ranges from 0... 2 idBaseBitLength - 1 . Selects which digit to use.
  Returns:
    a read-only set of possible handles located at that position in the routing table, or null if none are known

### getBestEntry

    public RouteSet getBestEntry(Id key)

  Gets the set of handles that match at least one more digit of the key than the local nodeId.

  Parameters:
    `key` - the key
  Returns:
    a read-only set of possible handles, or null if none are known

### get

    public NodeHandle get(NodeId nid)

  Gets the node handle associated with a given id.

  Parameters:
    `nid` - a node id
  Returns:
    the handle associated with that id, or null if none is known.

### getRow

    public RouteSet[] getRow(int i)

  Get a row from the routing table.

  Parameters:
    `i` - which row
  Returns:
    an array which is the ith row.

### numColumns

    public int numColumns()

  return ths number of columns in the routing table

  Returns:
    number of columns

### numRows

    public int numRows()

  return the number of rows in the routing table

  Returns:
    number of rows

### baseBitLength

    public int baseBitLength()

  return the bit length of the base

  Returns:
    baseBitLength

### bestAlternateRoute

    public NodeHandle bestAlternateRoute(Id key)

  Determines an alternate hop numerically closer to the key than the one we are at. This assumes that bestEntry did not produce a live nodeHandle that matches the next digit of the key.

  Parameters:
    `key` - the key
  Returns:
    a nodeHandle of a numerically closer node, relative to the key

### bestAlternateRoute

    public NodeHandle bestAlternateRoute(int minLiveness,
                                         Id key)

  Determines an alternate hop numerically closer to the key than the one we are at. This assumes that bestEntry did not produce a live nodeHandle that matches the next digit of the key.

  Parameters:
    `key` - the key
    `minLiveness` - DESCRIBE THE PARAMETER
  Returns:
    a nodeHandle of a numerically closer node, relative to the key

### alternateRoutes

    public NodeSet alternateRoutes(Id key,
                                   int max)

  Determines a set of alternate hops towards a given key.

  Parameters:
    `key` - the key
    `max` - the maximal number of alternate hops requested
  Returns:
    a set of nodehandles, or null if no alternate hops exist

### put

    public void put(NodeHandle handle)

  Puts a handle into the routing table.

  Parameters:
    `handle` - the handle to put.

### remove

    public NodeHandle remove(NodeHandle nh)

  Removes a node id from the table.

  Parameters:
    `nh` - DESCRIBE THE PARAMETER
  Returns:
    the handle that was removed, or null if it did not exist.

### update

    public void update(java.util.Observable o,
                       java.lang.Object arg)

  Is called by the Observer pattern whenever a RouteSet in this table has changed.

  Specified by:
    `update` in interface `java.util.Observer`
  Parameters:
    `o` - the RouteSet
    `arg` - the event

### toString

    public java.lang.String toString()

  produces a String representation of the routing table, showing the number of node handles in each entry

  Returns:
    DESCRIBE THE RETURN VALUE

### numEntries

    public int numEntries()

  DESCRIBE THE METHOD

  Returns:
    DESCRIBE THE RETURN VALUE

### numUniqueEntries

    public int numUniqueEntries()

  DESCRIBE THE METHOD

  Returns:
    DESCRIBE THE RETURN VALUE

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005 - Rice Pastry.